<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="dez-label-bar-edit-tags-list.html">
<link rel="import" href="dez-label-bar-buttons.html">
<link rel="import" href="dez-plus-input.html">

<dom-module id="dez-edit-bar">
  <template>
    <style>
      #tagEditor {
        margin-left: auto;
      }
    </style>
    <app-toolbar>
      <dez-label-bar-edit-tags-list id="tagsEditor" tags="{{_tagsNames}}"></dez-label-bar-edit-tags-list>
      <dez-label-bar-buttons
        id="buttons"
        buttons-data="[[tags]]"
        selected-name="{{activeTag}}">
      </dez-label-bar-buttons>
      <dez-plus-input
        id="tagEditor"
        value="{{selectedInput}}"
        visible="[[_aLabelIsSelected]]"
        plus-visible="[[_addButtonVisible]]">
      </dez-plus-input>
    </app-toolbar>
  </template>

  <script>
    class DezEditBar extends Polymer.Element {

      static get is() { return 'dez-edit-bar'; }

      /**
      * Fired when a tag button is taped.
      *
      * @event tag-btn-tap
      */

      /**
      * Fired when the tag list is changed from the tag list editor
      *
      * @event tags-list-changed
      */

      /**
      * Fired when the plus button of the tag editor is taped
      *
      * @event plus-btn-tap
      */

      static get properties() {
        return {
          tags: {
            type: Array,
            observer: "_tagsChangedHandler"
          },
          activeTag: {
            type: String,
            notify: true
          },
          selectedInput: {
            type: String,
            notify: true,
            observer: '_selectedInputChangedHandler'
          }
        };
      }

      ready () {
        super.ready()
        this.$.buttons.addEventListener('button-taped', () => {
          this.dispatchEvent(new CustomEvent('tag-btn-tap', {
            detail : {
              tag : this.activeTag
            }
          }))
        })
        this.$.tagsEditor.addEventListener('tags-changed', () => {
          this.dispatchEvent(new CustomEvent('tags-list-changed', {
            detail: { names : this._tagsNames }
          }))
        })
        this.$.tagEditor.addEventListener('value-changed', () => {
          this.$.tagEditor.plusVisible = !this.tags.map(
            tag => tag.name
          ).includes(this.selectedInput)
        })
        this.$.tagEditor.addEventListener('plus-tap', () => {
          this.dispatchEvent(new CustomEvent('plus-btn-tap'))
        })
        this.$.tagEditor.visible = false
        this.$.tagEditor.plusVisible = false
      }

      _tagsChangedHandler () {
        this._tagsNames = this.tags.map(tag => tag.name)
        if (this.$.tagEditor && this.selectedInput) {
          this.$.tagEditor.plusVisible = !this.tags.map(
            tag => tag.name
          ).includes(this.selectedInput)
        }
      }

      _selectedInputChangedHandler () {
        this.$.tagEditor.visible = this.selectedInput != undefined
      }

    }

    window.customElements.define(DezEditBar.is, DezEditBar);
  </script>
</dom-module>
